Package org.apache.tapestry5.ioc.def

# Interface ModuleDef

All Known Subinterfaces:
  `ModuleDef2`

All Known Implementing Classes:
  `DefaultModuleDefImpl`, `SpringModuleDef`, `SyntheticModuleDef`

public interface ModuleDef
Defines the contents of a module. In the default case, this is information about the services provided by the module builder class.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Class`
  `getBuilderClass()`
  Returns the class that will be instantiated.
  `Set<ContributionDef>`
  `getContributionDefs()`
  Returns all the contribution definitions built/provided by this module.
  `Set<DecoratorDef>`
  `getDecoratorDefs()`
  Returns all the decorator definitions built/provided by this module.
  `String`
  `getLoggerName()`
  Returns the name used to create a `Logger` instance.
  `ServiceDef`
  `getServiceDef(String serviceId)`
  Returns a service definition via the service's id.
  `Set<String>`
  `getServiceIds()`
  Returns the ids of the services built/provided by the module.

- ## Method Details

  - ### getServiceIds

    Set<String> getServiceIds()
    Returns the ids of the services built/provided by the module.

  - ### getServiceDef

    ServiceDef getServiceDef(String serviceId)
    Returns a service definition via the service's id. Ideally, the returned value should be an instance of `ServiceDef2`, and will be converted to such if necessary.
    Parameters:
      `serviceId` - the id of the service to retrieve (case is ignored)
    Returns:
      service definition or null if it doesn't exist

  - ### getDecoratorDefs

    Set<DecoratorDef> getDecoratorDefs()
    Returns all the decorator definitions built/provided by this module.

  - ### getContributionDefs

    Set<ContributionDef> getContributionDefs()
    Returns all the contribution definitions built/provided by this module.

  - ### getBuilderClass

    Class getBuilderClass()
    Returns the class that will be instantiated. Annotated instance methods of this class are invoked to build services, to decorate/intercept services, and make contributions to other services. Note: this name is maintained for compatibilty; the term "module builder" is now just "module class".

  - ### getLoggerName

    String getLoggerName()
    Returns the name used to create a `Logger` instance. This is typically the builder class name.